diff --git a/libavcodec/aactab.c b/libavcodec/aactab.c
index dfb2dfd98d..18afa69bad 100644
--- a/libavcodec/aactab.c
+++ b/libavcodec/aactab.c
@@ -154,6 +154,10 @@ const uint8_t ff_aac_num_swb_960[] = {
     40, 40, 46, 49, 49, 49, 46, 46, 42, 42, 42, 40, 40
 };
 
+const uint8_t ff_aac_num_swb_768[] = {
+    37, 37, 41, 43, 43, 43, 43, 43, 39, 39, 39, 37, 37
+};
+
 const uint8_t ff_aac_num_swb_512[] = {
      0,  0,  0, 36, 36, 37, 31, 31,  0,  0,  0,  0,  0
 };
@@ -170,6 +174,10 @@ const uint8_t ff_aac_num_swb_120[] = {
     12, 12, 12, 14, 14, 14, 15, 15, 15, 15, 15, 15, 15
 };
 
+const uint8_t ff_aac_num_swb_96[] = {
+    12, 12, 12, 12, 12, 12, 14, 14, 14, 14, 14, 14, 14
+};
+
 const uint8_t ff_aac_pred_sfb_max[] = {
     33, 33, 38, 40, 40, 40, 41, 41, 37, 37, 37, 34, 34
 };
@@ -1806,6 +1814,99 @@ static const uint16_t swb_offset_120_8[] =
     0, 4, 8, 12, 16,  20, 24, 28, 36, 44, 52, 60, 72, 88, 108, 120
 };
 
+static const uint16_t swb_offset_768_96[] =
+{
+    0,   4,   8,   12,  16,  20,  24,  28,  32,  36,
+    40,  44,  48,  52,  56,  64,  72,  80,  88,  96,
+    108, 120, 132, 144, 156, 172, 188, 212, 240, 276,
+    320, 384, 448, 512, 576, 640, 704, 768
+};
+
+static const uint16_t swb_offset_768_64[] =
+{
+    0,   4,   8,   12,  16,  20,  24,  28,  32,  36,  40,
+    44,  48,  52,  56,  64,  72,  80,  88,  100, 112, 124,
+    140, 156, 172, 192, 216, 240, 268, 304, 344, 384, 424,
+    464, 504, 544, 584, 624, 664, 704, 744, 768
+};
+
+static const uint16_t swb_offset_768_48[] =
+{
+    0,   4,   8,   12,  16,  20,  24,  28,  32,  36,  40,  48,
+    56,  64,  72,  80,  88,  96,  108, 120, 132, 144, 160, 176,
+    196, 216, 240, 264, 292, 320, 352, 384, 416, 448, 480, 512,
+    544, 576, 608, 640, 672, 704, 736, 768
+};
+
+static const uint16_t swb_offset_768_32[] =
+{
+    0,   4,   8,   12,  16,  20,  24,  28,  32,  36,  40,  48,
+    56,  64,  72,  80,  88,  96,  108, 120, 132, 144, 160, 176,
+    196, 216, 240, 264, 292, 320, 352, 384, 416, 448, 480, 512,
+    544, 576, 608, 640, 672, 704, 736, 768
+};
+
+static const uint16_t swb_offset_768_24[] =
+{
+    0,   4,   8,   12,  16,  20,  24,  28,  32,  36,  40,  44,
+    52,  60,  68,  76,  84,  92,  100, 108, 116, 124, 136, 148,
+    160, 172, 188, 204, 220, 240, 260, 284, 308, 336, 364, 396,
+    432, 468, 508, 552, 600, 652, 704, 768
+};
+
+static const uint16_t swb_offset_768_16[] =
+{
+    0,   8,   16,  24,  32,  40,  48,  56,  64,
+    72,  80,  88,  100, 112, 124, 136, 148, 160,
+    172, 184, 196, 212, 228, 244, 260, 280, 300,
+    320, 344, 368, 396, 424, 456, 492, 532, 572,
+    616, 664, 716, 768
+};
+
+static const uint16_t swb_offset_768_8[] =
+{
+    0,   12,  24,  36,  48,  60,  72,  84,  96,  108,
+    120, 132, 144, 156, 172, 188, 204, 220, 236, 252,
+    268, 288, 308, 328, 348, 372, 396, 420, 448, 476,
+    508, 544, 580, 620, 664, 712, 764, 768
+};
+
+static const uint16_t swb_offset_96_96[] =
+{
+    0,  4,  8,  12, 16, 20, 24,
+    32, 40, 48, 64, 92, 96
+};
+
+static const uint16_t swb_offset_96_64[] =
+{
+    0,  4,  8,  12, 16, 20, 24,
+    32, 40, 48, 64, 92, 96
+};
+
+static const uint16_t swb_offset_96_48[] =
+{
+    0,  4,  8,  12, 16, 20, 28,
+    36, 44, 56, 68, 80, 96
+};
+
+static const uint16_t swb_offset_96_24[] =
+{
+    0,  4,  8,  12, 16, 20, 24, 28,
+    36, 44, 52, 64, 76, 92, 96
+};
+
+static const uint16_t swb_offset_96_16[] =
+{
+    0,  4,  8,  12, 16, 20, 24, 28,
+    32, 40, 48, 60, 72, 88, 96
+};
+
+static const uint16_t swb_offset_96_8[] =
+{
+    0,  4,  8,  12, 16, 20, 24, 28,
+    36, 44, 52, 60, 72, 88, 96
+};
+
 const uint16_t * const ff_swb_offset_1024[] = {
     swb_offset_1024_96, swb_offset_1024_96, swb_offset_1024_64,
     swb_offset_1024_48, swb_offset_1024_48, swb_offset_1024_32,
@@ -1822,6 +1923,14 @@ const uint16_t * const ff_swb_offset_960[] = {
     swb_offset_960_8
 };
 
+const uint16_t * const ff_swb_offset_768[] = {
+    swb_offset_768_96, swb_offset_768_96, swb_offset_768_64,
+    swb_offset_768_48, swb_offset_768_48, swb_offset_768_32,
+    swb_offset_768_24, swb_offset_768_24, swb_offset_768_16,
+    swb_offset_768_16, swb_offset_768_16, swb_offset_768_8,
+    swb_offset_768_8
+};
+
 const uint16_t * const ff_swb_offset_512[] = {
     NULL,               NULL,               NULL,
     swb_offset_512_48,  swb_offset_512_48,  swb_offset_512_32,
@@ -1856,6 +1965,14 @@ const uint16_t * const ff_swb_offset_120[] = {
     swb_offset_120_8
 };
 
+const uint16_t * const ff_swb_offset_96[] = {
+    swb_offset_96_96, swb_offset_96_96, swb_offset_96_96,
+    swb_offset_96_48, swb_offset_96_48, swb_offset_96_48,
+    swb_offset_96_24, swb_offset_96_24, swb_offset_96_16,
+    swb_offset_96_16, swb_offset_96_16, swb_offset_96_8,
+    swb_offset_96_8
+};
+
 // @}
 
 /* @name ff_tns_max_bands
diff --git a/libavcodec/aactab.h b/libavcodec/aactab.h
index 9d584ebbe5..481fc57d93 100644
--- a/libavcodec/aactab.h
+++ b/libavcodec/aactab.h
@@ -74,10 +74,12 @@ void ff_aac_float_common_init(void);
  */
 extern const uint8_t ff_aac_num_swb_1024[];
 extern const uint8_t ff_aac_num_swb_960 [];
+extern const uint8_t ff_aac_num_swb_768 [];
 extern const uint8_t ff_aac_num_swb_512 [];
 extern const uint8_t ff_aac_num_swb_480 [];
 extern const uint8_t ff_aac_num_swb_128 [];
 extern const uint8_t ff_aac_num_swb_120 [];
+extern const uint8_t ff_aac_num_swb_96  [];
 // @}
 
 extern const uint8_t ff_aac_pred_sfb_max [];
@@ -101,10 +103,12 @@ extern const uint16_t ff_aac_ac_cf_m[64][17];
 
 extern const uint16_t * const ff_swb_offset_1024[13];
 extern const uint16_t * const ff_swb_offset_960 [13];
+extern const uint16_t * const ff_swb_offset_768 [13];
 extern const uint16_t * const ff_swb_offset_512 [13];
 extern const uint16_t * const ff_swb_offset_480 [13];
 extern const uint16_t * const ff_swb_offset_128 [13];
 extern const uint16_t * const ff_swb_offset_120 [13];
+extern const uint16_t * const ff_swb_offset_96  [13];
 
 extern const uint8_t ff_tns_max_bands_1024[13];
 extern const uint8_t ff_tns_max_bands_512 [13];